diff -Naur openssl-1.0.0q.orig/crypto/evp/e_idea.c openssl-1.0.0q/crypto/evp/e_idea.c
--- openssl-1.0.0q.orig/crypto/evp/e_idea.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/e_idea.c	2017-04-25 16:23:40.343322402 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 
 #ifndef OPENSSL_NO_IDEA
 #include <openssl/evp.h>
diff -Naur openssl-1.0.0q.orig/crypto/evp/e_null.c openssl-1.0.0q/crypto/evp/e_null.c
--- openssl-1.0.0q.orig/crypto/evp/e_null.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/e_null.c	2017-04-25 16:23:40.344321691 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/evp.h>
 #include <openssl/objects.h>
@@ -88,7 +90,7 @@
 static int null_init_key(EVP_CIPHER_CTX *ctx, const unsigned char *key,
 	     const unsigned char *iv, int enc)
 	{
-	/*	memset(&(ctx->c),0,sizeof(ctx->c));*/
+	/*	op_memset(&(ctx->c),0,sizeof(ctx->c));*/
 	return 1;
 	}
 
@@ -96,7 +98,7 @@
 	     const unsigned char *in, size_t inl)
 	{
 	if (in != out)
-		memcpy((char *)out,(const char *)in,inl);
+		op_memcpy((char *)out,(const char *)in,inl);
 	return 1;
 	}
 
diff -Naur openssl-1.0.0q.orig/crypto/evp/e_rc2.c openssl-1.0.0q/crypto/evp/e_rc2.c
--- openssl-1.0.0q.orig/crypto/evp/e_rc2.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/e_rc2.c	2017-04-25 16:23:40.345321260 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 
 #ifndef OPENSSL_NO_RC2
 
@@ -65,13 +67,16 @@
 #include <openssl/objects.h>
 #include "evp_locl.h"
 #include <openssl/rc2.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 static int rc2_init_key(EVP_CIPHER_CTX *ctx, const unsigned char *key,
 			const unsigned char *iv,int enc);
+#ifndef OPERA_SMALL_VERSION
 static int rc2_meth_to_magic(EVP_CIPHER_CTX *ctx);
 static int rc2_magic_to_meth(int i);
 static int rc2_set_asn1_type_and_iv(EVP_CIPHER_CTX *c, ASN1_TYPE *type);
 static int rc2_get_asn1_type_and_iv(EVP_CIPHER_CTX *c, ASN1_TYPE *type);
+#endif
 static int rc2_ctrl(EVP_CIPHER_CTX *c, int type, int arg, void *ptr);
 
 typedef struct
@@ -94,6 +99,7 @@
 #define RC2_64_MAGIC	0x78
 #define RC2_128_MAGIC	0x3a
 
+#ifndef OPERA_SMALL_VERSION
 static const EVP_CIPHER r2_64_cbc_cipher=
 	{
 	NID_rc2_64_cbc,
@@ -108,30 +114,32 @@
 	rc2_ctrl,
 	NULL
 	};
+#endif
 
-static const EVP_CIPHER r2_40_cbc_cipher=
-	{
+CONST_EVP_CIPHER_ITEM(r2_40_cbc_cipher,
 	NID_rc2_40_cbc,
 	8,5 /* 40 bit */,8,
 	EVP_CIPH_CBC_MODE | EVP_CIPH_VARIABLE_LENGTH | EVP_CIPH_CTRL_INIT,
 	rc2_init_key,
 	rc2_cbc_cipher,
 	NULL,
-	sizeof(EVP_RC2_KEY),
-	rc2_set_asn1_type_and_iv,
-	rc2_get_asn1_type_and_iv,
+	EVP_RC2_KEY,
+	OPERA_SET_GET_ASN1_PARAM_FN(rc2_set_asn1_type_and_iv),
+	OPERA_SET_GET_ASN1_PARAM_FN(rc2_get_asn1_type_and_iv),
 	rc2_ctrl,
 	NULL
-	};
+	);
 
+#ifndef OPERA_SMALL_VERSION
 const EVP_CIPHER *EVP_rc2_64_cbc(void)
 	{
 	return(&r2_64_cbc_cipher);
 	}
+#endif
 
 const EVP_CIPHER *EVP_rc2_40_cbc(void)
 	{
-	return(&r2_40_cbc_cipher);
+	return(&OPENSSL_GLOBAL_ITEM_NAME(r2_40_cbc_cipher));
 	}
 	
 static int rc2_init_key(EVP_CIPHER_CTX *ctx, const unsigned char *key,
@@ -142,6 +150,7 @@
 	return 1;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 static int rc2_meth_to_magic(EVP_CIPHER_CTX *e)
 	{
 	int i;
@@ -171,7 +180,7 @@
 	int i=0;
 	int key_bits;
 	unsigned int l;
-	unsigned char iv[EVP_MAX_IV_LENGTH];
+	unsigned char iv[EVP_MAX_IV_LENGTH]; /* ARRAY OK UNUSED 2009-05-25 yngve */
 
 	if (type != NULL)
 		{
@@ -203,6 +212,7 @@
 		}
 	return(i);
 	}
+#endif
 
 static int rc2_ctrl(EVP_CIPHER_CTX *c, int type, int arg, void *ptr)
 	{
diff -Naur openssl-1.0.0q.orig/crypto/evp/e_rc4.c openssl-1.0.0q/crypto/evp/e_rc4.c
--- openssl-1.0.0q.orig/crypto/evp/e_rc4.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/e_rc4.c	2017-04-25 16:23:40.346321666 +0200
@@ -56,14 +56,18 @@
  * [including the GNU Public Licence.]
  */
 
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 
 #ifndef OPENSSL_NO_RC4
 
 #include <openssl/evp.h>
 #include <openssl/objects.h>
 #include <openssl/rc4.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* FIXME: surely this is available elsewhere? */
 #define EVP_RC4_KEY_SIZE		16
@@ -79,45 +83,70 @@
 			const unsigned char *iv,int enc);
 static int rc4_cipher(EVP_CIPHER_CTX *ctx, unsigned char *out,
 		      const unsigned char *in, size_t inl);
-static const EVP_CIPHER r4_cipher=
-	{
+CONST_EVP_CIPHER_ITEM(r4_cipher,
 	NID_rc4,
 	1,EVP_RC4_KEY_SIZE,0,
 	EVP_CIPH_VARIABLE_LENGTH,
 	rc4_init_key,
 	rc4_cipher,
 	NULL,
-	sizeof(EVP_RC4_KEY),
+	EVP_RC4_KEY,
 	NULL,
 	NULL,
 	NULL,
 	NULL
-	};
+	);
 
-static const EVP_CIPHER r4_40_cipher=
-	{
+#ifdef LIBOPEAY_USE_RC4_256
+CONST_EVP_CIPHER_ITEM(r4_256_cipher,
+	NID_rc4,
+	1,32 /*256 bits*/ ,0,
+	EVP_CIPH_VARIABLE_LENGTH,
+	rc4_init_key,
+	rc4_cipher,
+	NULL,
+	EVP_RC4_KEY,
+	NULL,
+	NULL,
+	NULL,
+	NULL
+	);
+#endif
+
+#if !defined OPERA_SMALL_VERSION ||defined SSL_USE_WEAK_CIPHERS
+CONST_EVP_CIPHER_ITEM(r4_40_cipher,
 	NID_rc4_40,
 	1,5 /* 40 bit */,0,
 	EVP_CIPH_VARIABLE_LENGTH,
 	rc4_init_key,
 	rc4_cipher,
 	NULL,
-	sizeof(EVP_RC4_KEY),
+	EVP_RC4_KEY,
 	NULL, 
 	NULL,
 	NULL,
 	NULL
-	};
+	);
+#endif
 
 const EVP_CIPHER *EVP_rc4(void)
 	{
-	return(&r4_cipher);
+	return(&OPENSSL_GLOBAL_ITEM_NAME(r4_cipher));
 	}
 
+#ifdef LIBOPEAY_USE_RC4_256
+const EVP_CIPHER *EVP_rc4_256(void)
+	{
+	return(&OPENSSL_GLOBAL_ITEM_NAME(r4_256_cipher));
+	}
+#endif
+
+#if !defined OPERA_SMALL_VERSION ||defined SSL_USE_WEAK_CIPHERS
 const EVP_CIPHER *EVP_rc4_40(void)
 	{
-	return(&r4_40_cipher);
+	return(&OPENSSL_GLOBAL_ITEM_NAME(r4_40_cipher));
 	}
+#endif
 
 static int rc4_init_key(EVP_CIPHER_CTX *ctx, const unsigned char *key,
 			const unsigned char *iv, int enc)
diff -Naur openssl-1.0.0q.orig/crypto/evp/e_rc5.c openssl-1.0.0q/crypto/evp/e_rc5.c
--- openssl-1.0.0q.orig/crypto/evp/e_rc5.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/e_rc5.c	2017-04-25 16:23:40.346321666 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 
 #ifndef OPENSSL_NO_RC5
 
diff -Naur openssl-1.0.0q.orig/crypto/evp/e_xcbc_d.c openssl-1.0.0q/crypto/evp/e_xcbc_d.c
--- openssl-1.0.0q.orig/crypto/evp/e_xcbc_d.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/e_xcbc_d.c	2017-04-25 16:23:40.348322479 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 
 #ifndef OPENSSL_NO_DES
 
@@ -107,8 +109,8 @@
 	DES_cblock *deskey = (DES_cblock *)key;
 
 	DES_set_key_unchecked(deskey,&data(ctx)->ks);
-	memcpy(&data(ctx)->inw[0],&key[8],8);
-	memcpy(&data(ctx)->outw[0],&key[16],8);
+	op_memcpy(&data(ctx)->inw[0],&key[8],8);
+	op_memcpy(&data(ctx)->outw[0],&key[16],8);
 
 	return 1;
 	}
diff -Naur openssl-1.0.0q.orig/crypto/evp/encode.c openssl-1.0.0q/crypto/evp/encode.c
--- openssl-1.0.0q.orig/crypto/evp/encode.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/encode.c	2017-04-25 16:23:40.349322327 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/evp.h>
 
 #ifndef CHARSET_EBCDIC
@@ -139,14 +141,14 @@
 	OPENSSL_assert(ctx->length <= (int)sizeof(ctx->enc_data));
 	if ((ctx->num+inl) < ctx->length)
 		{
-		memcpy(&(ctx->enc_data[ctx->num]),in,inl);
+		op_memcpy(&(ctx->enc_data[ctx->num]),in,inl);
 		ctx->num+=inl;
 		return;
 		}
 	if (ctx->num != 0)
 		{
 		i=ctx->length-ctx->num;
-		memcpy(&(ctx->enc_data[ctx->num]),in,i);
+		op_memcpy(&(ctx->enc_data[ctx->num]),in,i);
 		in+=i;
 		inl-=i;
 		j=EVP_EncodeBlock(out,ctx->enc_data,ctx->length);
@@ -167,7 +169,7 @@
 		total+=j+1;
 		}
 	if (inl != 0)
-		memcpy(&(ctx->enc_data[0]),in,inl);
+		op_memcpy(&(ctx->enc_data[0]),in,inl);
 	ctx->num=inl;
 	*outl=total;
 	}
diff -Naur openssl-1.0.0q.orig/crypto/evp/evp.h openssl-1.0.0q/crypto/evp/evp.h
--- openssl-1.0.0q.orig/crypto/evp/evp.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/evp.h	2017-04-25 16:23:40.351322581 +0200
@@ -181,6 +181,45 @@
 	int (*md_ctrl)(EVP_MD_CTX *ctx, int cmd, int p1, void *p2);
 	} /* EVP_MD */;
 
+#if !defined(OPERA_SMALL_VERSION)
+#define CONST_EVP_MD_ITEM_REQUIRED_TYPE_IMPL(_sign, _verify, u,v,x,y,z) _sign, _verify, {u,v,x,y,z},
+#else
+#define CONST_EVP_MD_ITEM_REQUIRED_TYPE_IMPL(_sign, _verify, u,v,x,y,z) CONST_EVP_MD_ITEM_REQUIRED_TYPE( _sign, _verify, u,v,x,y,z)
+#if defined(HAS_COMPLEX_GLOBALS)
+#define CONST_EVP_MD_ITEM_REQUIRED_TYPE(_sign, _verify, u,v,x,y,z)  , _sign, _verify, {u,v,x,y,z}
+#else
+#define CONST_EVP_MD_ITEM_REQUIRED_TYPE(_sign, _verify,u,v,x,y,z) \
+	CONST_ITEM_ENTRY_SINGLE(sign,_sign)\
+	CONST_ITEM_ENTRY_SINGLE(verify,_verify)\
+	CONST_ITEM_ENTRY_SINGLE(required_pkey_type[0], u)\
+	CONST_ITEM_ENTRY_SINGLE(required_pkey_type[1], v)\
+	CONST_ITEM_ENTRY_SINGLE(required_pkey_type[2], x)\
+	CONST_ITEM_ENTRY_SINGLE(required_pkey_type[3], y)\
+	CONST_ITEM_ENTRY_SINGLE(required_pkey_type[4], z)
+#endif
+#endif
+
+#define CONST_EVP_MD_ITEM(cname, _type, _pkey_type, _md_size, _flags, \
+			_init, _update, _final, _copy, _cleanup,\
+			required, _block_size, _ctx_size) \
+	OPENSSL_PREFIX_CONST_ITEM(static, EVP_MD, cname, libopeay)\
+	CONST_ITEM_ENTRY_START(type,_type) \
+	CONST_ITEM_ENTRY_SINGLE(pkey_type,_pkey_type)\
+	CONST_ITEM_ENTRY_SINGLE(md_size,_md_size)\
+	CONST_ITEM_ENTRY_SINGLE(flags, _flags)\
+	CONST_ITEM_ENTRY_SINGLE(init, _init)\
+	CONST_ITEM_ENTRY_SINGLE(update,_update)\
+	CONST_ITEM_ENTRY_SINGLE(final,_final)\
+	CONST_ITEM_ENTRY_SINGLE(copy,_copy)\
+	CONST_ITEM_ENTRY_SINGLE(cleanup, _cleanup)\
+	required\
+	CONST_ITEM_ENTRY_SINGLE(block_size,_block_size)\
+	CONST_ITEM_ENTRY_SINGLE(ctx_size, _ctx_size)\
+	CONST_ITEM_ENTRY_SINGLE(md_ctrl, NULL)\
+	CONST_ITEM_ENTRY_END
+
+#define DECLARE_EVP_MD_ITEM(cname) DECLARE_MODULE_CONST_ITEM(EVP_MD, cname)
+
 typedef int evp_sign_method(int type,const unsigned char *m,
 			    unsigned int m_length,unsigned char *sigret,
 			    unsigned int *siglen, void *key);
@@ -225,33 +264,33 @@
 
 #define	EVP_MD_CTRL_ALG_CTRL			0x1000
 
-#define EVP_PKEY_NULL_method	NULL,NULL,{0,0,0,0}
+#define EVP_PKEY_NULL_method	CONST_EVP_MD_ITEM_REQUIRED_TYPE_IMPL(NULL,NULL, 0,0,0,0,0)
 
 #ifndef OPENSSL_NO_DSA
-#define EVP_PKEY_DSA_method	(evp_sign_method *)DSA_sign, \
+#define EVP_PKEY_DSA_method	CONST_EVP_MD_ITEM_REQUIRED_TYPE_IMPL((evp_sign_method *)DSA_sign, \
 				(evp_verify_method *)DSA_verify, \
-				{EVP_PKEY_DSA,EVP_PKEY_DSA2,EVP_PKEY_DSA3, \
-					EVP_PKEY_DSA4,0}
+				EVP_PKEY_DSA,EVP_PKEY_DSA2,EVP_PKEY_DSA3, \
+					EVP_PKEY_DSA4,0)
 #else
 #define EVP_PKEY_DSA_method	EVP_PKEY_NULL_method
 #endif
 
 #ifndef OPENSSL_NO_ECDSA
-#define EVP_PKEY_ECDSA_method   (evp_sign_method *)ECDSA_sign, \
+#define EVP_PKEY_ECDSA_method  CONST_EVP_MD_ITEM_REQUIRED_TYPE_IMPL( (evp_sign_method *)ECDSA_sign, \
 				(evp_verify_method *)ECDSA_verify, \
-                                 {EVP_PKEY_EC,0,0,0}
+                                 EVP_PKEY_EC,0,0,0,0)
 #else   
 #define EVP_PKEY_ECDSA_method   EVP_PKEY_NULL_method
 #endif
 
 #ifndef OPENSSL_NO_RSA
-#define EVP_PKEY_RSA_method	(evp_sign_method *)RSA_sign, \
+#define EVP_PKEY_RSA_method	CONST_EVP_MD_ITEM_REQUIRED_TYPE_IMPL((evp_sign_method *)RSA_sign, \
 				(evp_verify_method *)RSA_verify, \
-				{EVP_PKEY_RSA,EVP_PKEY_RSA2,0,0}
-#define EVP_PKEY_RSA_ASN1_OCTET_STRING_method \
+				EVP_PKEY_RSA,EVP_PKEY_RSA2,0,0,0)
+#define EVP_PKEY_RSA_ASN1_OCTET_STRING_method CONST_EVP_MD_ITEM_REQUIRED_TYPE_IMPL(\
 				(evp_sign_method *)RSA_sign_ASN1_OCTET_STRING, \
 				(evp_verify_method *)RSA_verify_ASN1_OCTET_STRING, \
-				{EVP_PKEY_RSA,EVP_PKEY_RSA2,0,0}
+				EVP_PKEY_RSA,EVP_PKEY_RSA2,0,0,0)
 #else
 #define EVP_PKEY_RSA_method	EVP_PKEY_NULL_method
 #define EVP_PKEY_RSA_ASN1_OCTET_STRING_method EVP_PKEY_NULL_method
@@ -316,6 +355,41 @@
 	void *app_data;		/* Application data */
 	} /* EVP_CIPHER */;
 
+#ifndef OPERA_SMALL_VERSION
+#define OPERA_SET_GET_ASN1_PARAM_FN(f) f
+#else
+#define OPERA_SET_GET_ASN1_PARAM_FN(f) NULL
+#endif
+
+#define CONST_EVP_CIPHER_ITEM(cname, _nid, _block_size, \
+			  _key_len, _iv_len, _flags, _init_key, _do_cipher, _cleanup, \
+			  kstruct, _set_asn1, _get_asn1, _ctrl, _app_data) \
+OPENSSL_PREFIX_CONST_ITEM(static, EVP_CIPHER, cname, libopeay) \
+	CONST_ITEM_ENTRY_START(nid,_nid) \
+	CONST_ITEM_ENTRY_SINGLE(block_size, _block_size)\
+	CONST_ITEM_ENTRY_SINGLE(key_len, _key_len)\
+	CONST_ITEM_ENTRY_SINGLE(iv_len, _iv_len)\
+	CONST_ITEM_ENTRY_SINGLE(flags, _flags)\
+	CONST_ITEM_ENTRY_SINGLE(init, _init_key)\
+	CONST_ITEM_ENTRY_SINGLE(do_cipher, _do_cipher)\
+	CONST_ITEM_ENTRY_SINGLE(cleanup, _cleanup)\
+	CONST_ITEM_ENTRY_SINGLE(ctx_size, sizeof(kstruct))\
+	CONST_ITEM_ENTRY_SINGLE(set_asn1_parameters, _set_asn1)\
+	CONST_ITEM_ENTRY_SINGLE(get_asn1_parameters, _get_asn1)\
+	CONST_ITEM_ENTRY_SINGLE(ctrl, _ctrl)\
+	CONST_ITEM_ENTRY_SINGLE(app_data, _app_data)\
+	CONST_ITEM_ENTRY_END
+
+#define DECLARE_EVP_CIPHER_ITEM(cname) DECLARE_MODULE_CONST_ITEM(EVP_CIPHER, cname)
+
+#ifdef OPENSSL_USE_CFB_CIPHERS
+#define DECLARE_BLOCK_CIPHER(cname) \
+		DECLARE_EVP_CIPHER_ITEM(EVP_CIPHER, cname##_cbc);\
+		DECLARE_EVP_CIPHER_ITEM(EVP_CIPHER, cname##_cbfb)
+#else
+#define DECLARE_BLOCK_CIPHER(cname) DECLARE_EVP_CIPHER_ITEM(cname##_cbc)
+#endif
+
 /* Values for cipher flags */
 
 /* Modes for ciphers */
@@ -362,7 +436,7 @@
 typedef struct evp_cipher_info_st
 	{
 	const EVP_CIPHER *cipher;
-	unsigned char iv[EVP_MAX_IV_LENGTH];
+	unsigned char iv[EVP_MAX_IV_LENGTH]; /* ARRAY OK UNUSED 2009-05-25 yngve */
 	} EVP_CIPHER_INFO;
 
 struct evp_cipher_ctx_st
@@ -372,9 +446,9 @@
 	int encrypt;		/* encrypt or decrypt */
 	int buf_len;		/* number we have left */
 
-	unsigned char  oiv[EVP_MAX_IV_LENGTH];	/* original iv */
-	unsigned char  iv[EVP_MAX_IV_LENGTH];	/* working iv */
-	unsigned char buf[EVP_MAX_BLOCK_LENGTH];/* saved partial block */
+	unsigned char  oiv[EVP_MAX_IV_LENGTH];	/* original iv */ /* ARRAY OK 2009-05-25 yngve */
+	unsigned char  iv[EVP_MAX_IV_LENGTH];	/* working iv */ /* ARRAY OK 2009-05-25 yngve */
+	unsigned char buf[EVP_MAX_BLOCK_LENGTH];/* saved partial block */ /* ARRAY OK 2009-05-25 yngve */
 	int num;				/* used by cfb/ofb mode */
 
 	void *app_data;		/* application stuff */
@@ -383,7 +457,7 @@
 	void *cipher_data; /* per EVP data */
 	int final_used;
 	int block_mask;
-	unsigned char final[EVP_MAX_BLOCK_LENGTH];/* possible final block */
+	unsigned char final[EVP_MAX_BLOCK_LENGTH];/* possible final block */ /* ARRAY OK 2009-05-25 yngve */
 	} /* EVP_CIPHER_CTX */;
 
 typedef struct evp_Encode_Ctx_st
@@ -394,7 +468,7 @@
 			 * length that is ok.  Once decoding begins,
 			 * the length is adjusted up each time a longer
 			 * line is decoded */
-	unsigned char enc_data[80];	/* data to encode */
+	unsigned char enc_data[80];	/* data to encode */ /* ARRAY OK 2009-05-25 yngve */
 	int line_num;	/* number read on current line */
 	int expect_nl;
 	} EVP_ENCODE_CTX;
@@ -612,9 +686,9 @@
 int EVP_CIPHER_CTX_rand_key(EVP_CIPHER_CTX *ctx, unsigned char *key);
 
 #ifndef OPENSSL_NO_BIO
-BIO_METHOD *BIO_f_md(void);
-BIO_METHOD *BIO_f_base64(void);
-BIO_METHOD *BIO_f_cipher(void);
+const BIO_METHOD *BIO_f_md(void);
+const BIO_METHOD *BIO_f_base64(void);
+const BIO_METHOD *BIO_f_cipher(void);
 BIO_METHOD *BIO_f_reliable(void);
 void BIO_set_cipher(BIO *b,const EVP_CIPHER *c,const unsigned char *k,
 		const unsigned char *i, int enc);
@@ -695,6 +769,7 @@
 #ifndef OPENSSL_NO_RC4
 const EVP_CIPHER *EVP_rc4(void);
 const EVP_CIPHER *EVP_rc4_40(void);
+const EVP_CIPHER *EVP_rc4_256(void);
 #endif
 #ifndef OPENSSL_NO_IDEA
 const EVP_CIPHER *EVP_idea_ecb(void);
diff -Naur openssl-1.0.0q.orig/crypto/evp/evp_enc.c openssl-1.0.0q/crypto/evp/evp_enc.c
--- openssl-1.0.0q.orig/crypto/evp/evp_enc.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/evp_enc.c	2017-04-25 16:23:40.352324664 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/evp.h>
 #include <openssl/err.h>
 #include <openssl/rand.h>
@@ -65,22 +67,29 @@
 #include <openssl/engine.h>
 #endif
 #include "evp_locl.h"
+#ifndef OPERA_SMALL_VERSION
+#include <assert.h>
+#endif /* !OPERA_SMALL_VERSION */
 
-const char EVP_version[]="EVP" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char EVP_version[]="EVP" OPENSSL_VERSION_PTEXT; /* ARRAY OK 2008-02-26 haavardm */
+#endif
 
 void EVP_CIPHER_CTX_init(EVP_CIPHER_CTX *ctx)
 	{
-	memset(ctx,0,sizeof(EVP_CIPHER_CTX));
+	op_memset(ctx,0,sizeof(EVP_CIPHER_CTX));
 	/* ctx->cipher=NULL; */
 	}
 
+#ifndef OPERA_SMALL_VERSION
 EVP_CIPHER_CTX *EVP_CIPHER_CTX_new(void)
 	{
-	EVP_CIPHER_CTX *ctx=OPENSSL_malloc(sizeof *ctx);
+	EVP_CIPHER_CTX *ctx=(EVP_CIPHER_CTX*) OPENSSL_malloc(sizeof *ctx);
 	if (ctx)
 		EVP_CIPHER_CTX_init(ctx);
 	return ctx;
 	}
+#endif
 
 int EVP_CipherInit(EVP_CIPHER_CTX *ctx, const EVP_CIPHER *cipher,
 	     const unsigned char *key, const unsigned char *iv, int enc)
@@ -171,6 +180,7 @@
 			}
 		ctx->key_len = cipher->key_len;
 		ctx->flags = 0;
+#if !defined OPERA_SMALL_VERSION ||defined SSL_USE_WEAK_CIPHERS  || !defined OPENSSL_NO_RC2
 		if(ctx->cipher->flags & EVP_CIPH_CTRL_INIT)
 			{
 			if(!EVP_CIPHER_CTX_ctrl(ctx, EVP_CTRL_INIT, 0, NULL))
@@ -179,6 +189,7 @@
 				return 0;
 				}
 			}
+#endif
 		}
 	else if(!ctx->cipher)
 		{
@@ -210,8 +221,8 @@
 
 			OPENSSL_assert(EVP_CIPHER_CTX_iv_length(ctx) <=
 					(int)sizeof(ctx->iv));
-			if(iv) memcpy(ctx->oiv, iv, EVP_CIPHER_CTX_iv_length(ctx));
-			memcpy(ctx->iv, ctx->oiv, EVP_CIPHER_CTX_iv_length(ctx));
+			if(iv) op_memcpy(ctx->oiv, iv, EVP_CIPHER_CTX_iv_length(ctx));
+			op_memcpy(ctx->iv, ctx->oiv, EVP_CIPHER_CTX_iv_length(ctx));
 			break;
 
 			default:
@@ -306,7 +317,7 @@
 		{
 		if (i+inl < bl)
 			{
-			memcpy(&(ctx->buf[i]),in,inl);
+			op_memcpy(&(ctx->buf[i]),in,inl);
 			ctx->buf_len+=inl;
 			*outl=0;
 			return 1;
@@ -314,7 +325,7 @@
 		else
 			{
 			j=bl-i;
-			memcpy(&(ctx->buf[i]),in,j);
+			op_memcpy(&(ctx->buf[i]),in,j);
 			if(!ctx->cipher->do_cipher(ctx,out,ctx->buf,bl)) return 0;
 			inl-=j;
 			in+=j;
@@ -333,7 +344,7 @@
 		}
 
 	if (i != 0)
-		memcpy(ctx->buf,&(in[inl]),i);
+		op_memcpy(ctx->buf,&(in[inl]),i);
 	ctx->buf_len=i;
 	return 1;
 	}
@@ -351,7 +362,7 @@
 	unsigned int i, b, bl;
 
 	b=ctx->cipher->block_size;
-	OPENSSL_assert(b <= sizeof ctx->buf);
+	OPENSSL_assert(b <= (int) sizeof ctx->buf);
 	if (b == 1)
 		{
 		*outl=0;
@@ -397,11 +408,11 @@
 		return EVP_EncryptUpdate(ctx, out, outl, in, inl);
 
 	b=ctx->cipher->block_size;
-	OPENSSL_assert(b <= sizeof ctx->final);
+	OPENSSL_assert(b <= (int) sizeof ctx->final);
 
 	if(ctx->final_used)
 		{
-		memcpy(out,ctx->final,b);
+		op_memcpy(out,ctx->final,b);
 		out+=b;
 		fix_len = 1;
 		}
@@ -418,7 +429,7 @@
 		{
 		*outl-=b;
 		ctx->final_used=1;
-		memcpy(ctx->final,&out[*outl],b);
+		op_memcpy(ctx->final,&out[*outl],b);
 		}
 	else
 		ctx->final_used = 0;
@@ -460,7 +471,7 @@
 			EVPerr(EVP_F_EVP_DECRYPTFINAL_EX,EVP_R_WRONG_FINAL_BLOCK_LENGTH);
 			return(0);
 			}
-		OPENSSL_assert(b <= sizeof ctx->final);
+		OPENSSL_assert(b <= (int) sizeof ctx->final);
 		n=ctx->final[b-1];
 		if (n == 0 || n > (int)b)
 			{
@@ -512,10 +523,11 @@
 		 * functional reference we held for this reason. */
 		ENGINE_finish(c->engine);
 #endif
-	memset(c,0,sizeof(EVP_CIPHER_CTX));
+	op_memset(c,0,sizeof(EVP_CIPHER_CTX));
 	return 1;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int EVP_CIPHER_CTX_set_key_length(EVP_CIPHER_CTX *c, int keylen)
 	{
 	if(c->cipher->flags & EVP_CIPH_CUSTOM_KEY_LENGTH) 
@@ -529,6 +541,7 @@
 	EVPerr(EVP_F_EVP_CIPHER_CTX_SET_KEY_LENGTH,EVP_R_INVALID_KEY_LENGTH);
 	return 0;
 	}
+#endif
 
 int EVP_CIPHER_CTX_set_padding(EVP_CIPHER_CTX *ctx, int pad)
 	{
@@ -584,7 +597,7 @@
 #endif
 
 	EVP_CIPHER_CTX_cleanup(out);
-	memcpy(out,in,sizeof *out);
+	op_memcpy(out,in,sizeof *out);
 
 	if (in->cipher_data && in->cipher->ctx_size)
 		{
@@ -594,7 +607,7 @@
 			EVPerr(EVP_F_EVP_CIPHER_CTX_COPY,ERR_R_MALLOC_FAILURE);
 			return 0;
 			}
-		memcpy(out->cipher_data,in->cipher_data,in->cipher->ctx_size);
+		op_memcpy(out->cipher_data,in->cipher_data,in->cipher->ctx_size);
 		}
 
 	if (in->cipher->flags & EVP_CIPH_CUSTOM_COPY)
diff -Naur openssl-1.0.0q.orig/crypto/evp/evp_err.c openssl-1.0.0q/crypto/evp/evp_err.c
--- openssl-1.0.0q.orig/crypto/evp/evp_err.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/evp_err.c	2017-04-25 16:23:40.352324664 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/evp.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/evp/evp_key.c openssl-1.0.0q/crypto/evp/evp_key.c
--- openssl-1.0.0q.orig/crypto/evp/evp_key.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/evp_key.c	2017-04-25 16:23:40.353321997 +0200
@@ -56,15 +56,18 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/x509.h>
 #include <openssl/objects.h>
 #include <openssl/evp.h>
 #include <openssl/ui.h>
 
+#ifndef _SSL_USE_OPENSSL_
 /* should be init to zeros. */
-static char prompt_string[80];
+static char prompt_string[80]; /* ARRAY OK UNUSED 2009-05-25 yngve */
 
 void EVP_set_pw_prompt(const char *prompt)
 	{
@@ -72,7 +75,7 @@
 		prompt_string[0]='\0';
 	else
 		{
-		strncpy(prompt_string,prompt,79);
+		op_strncpy(prompt_string,prompt,79);
 		prompt_string[79]='\0';
 		}
 	}
@@ -96,7 +99,7 @@
 int EVP_read_pw_string_min(char *buf, int min, int len, const char *prompt, int verify)
 	{
 	int ret;
-	char buff[BUFSIZ];
+	char buff[BUFSIZ]; /* ARRAY OK UNUSED 2009-05-25 yngve */
 	UI *ui;
 
 	if ((prompt == NULL) && (prompt_string[0] != '\0'))
@@ -112,12 +115,14 @@
 	return ret;
 	}
 
+#endif
+
 int EVP_BytesToKey(const EVP_CIPHER *type, const EVP_MD *md, 
 	     const unsigned char *salt, const unsigned char *data, int datal,
 	     int count, unsigned char *key, unsigned char *iv)
 	{
 	EVP_MD_CTX c;
-	unsigned char md_buf[EVP_MAX_MD_SIZE];
+	unsigned char md_buf[EVP_MAX_MD_SIZE]; /* ARRAY OK 2009-05-25 yngve */
 	int niv,nkey,addmd=0;
 	unsigned int mds=0,i;
 
diff -Naur openssl-1.0.0q.orig/crypto/evp/evp_lib.c openssl-1.0.0q/crypto/evp/evp_lib.c
--- openssl-1.0.0q.orig/crypto/evp/evp_lib.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/evp_lib.c	2017-04-25 16:23:40.354322404 +0200
@@ -56,8 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/evp.h>
 #include <openssl/objects.h>
 
@@ -96,7 +99,7 @@
 		if (i != (int)l)
 			return(-1);
 		else if (i > 0)
-			memcpy(c->iv,c->oiv,l);
+			op_memcpy(c->iv,c->oiv,l);
 		}
 	return(i);
 	}
@@ -214,6 +217,7 @@
 	ctx->app_data = data;
 	}
 
+#if defined(LIBOPEAY_PKCS12_SUPPORT) || defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION) || defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
 int EVP_CIPHER_iv_length(const EVP_CIPHER *cipher)
 	{
 	return cipher->iv_len;
@@ -228,6 +232,7 @@
 	{
 	return cipher->key_len;
 	}
+#endif
 
 int EVP_CIPHER_CTX_key_length(const EVP_CIPHER_CTX *ctx)
 	{
diff -Naur openssl-1.0.0q.orig/crypto/evp/evp_locl.h openssl-1.0.0q/crypto/evp/evp_locl.h
--- openssl-1.0.0q.orig/crypto/evp/evp_locl.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/evp_locl.h	2017-04-25 16:23:40.355322252 +0200
@@ -56,6 +56,9 @@
  *
  */
 
+#ifndef HEADER_EVP_LOCL_H
+#define HEADER_EVP_LOCL_H
+
 /* Macros to code block cipher wrappers */
 
 /* Wrapper functions for each cipher mode */
@@ -124,12 +127,24 @@
 	return 1;\
 }
 
+#if !defined(_SSL_USE_OPENSSL_) && !defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 #define BLOCK_CIPHER_all_funcs(cname, cprefix, cbits, kstruct, ksched) \
 	BLOCK_CIPHER_func_cbc(cname, cprefix, kstruct, ksched) \
 	BLOCK_CIPHER_func_cfb(cname, cprefix, cbits, kstruct, ksched) \
 	BLOCK_CIPHER_func_ecb(cname, cprefix, kstruct, ksched) \
 	BLOCK_CIPHER_func_ofb(cname, cprefix, cbits, kstruct, ksched)
+#else
+#ifdef OPENSSL_USE_CFB_CIPHERS
+#define BLOCK_CIPHER_all_funcs(cname, cprefix, cbits, kstruct, ksched) \
+	BLOCK_CIPHER_func_cbc(cname, cprefix, kstruct, ksched) \
+	BLOCK_CIPHER_func_cfb(cname, cprefix, cbits, kstruct, ksched)
+#else
+#define BLOCK_CIPHER_all_funcs(cname, cprefix, cbits, kstruct, ksched) \
+	BLOCK_CIPHER_func_cbc(cname, cprefix, kstruct, ksched)
+#endif
+#endif
 
+#if !defined(_SSL_USE_OPENSSL_) && !defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
 #define BLOCK_CIPHER_def1(cname, nmode, mode, MODE, kstruct, nid, block_size, \
 			  key_len, iv_len, flags, init_key, cleanup, \
 			  set_asn1, get_asn1, ctrl) \
@@ -145,6 +160,26 @@
 	NULL \
 }; \
 const EVP_CIPHER *EVP_##cname##_##mode(void) { return &cname##_##mode; }
+#else
+#if defined SSL_USE_WEAK_CIPHERS
+#define BLOCK_CIPHER_def1(cname, nmode, mode, MODE, kstruct, nid, block_size, \
+			  key_len, iv_len, flags, init_key, cleanup, \
+			  set_asn1, get_asn1, ctrl) \
+CONST_EVP_CIPHER_ITEM(cname##_##mode, nid##_##nmode, block_size, key_len, iv_len,\
+	((flags) | EVP_CIPH_##MODE##_MODE), init_key, cname##_##mode##_cipher, cleanup,\
+	kstruct, NULL , NULL, ctrl, NULL)\
+const EVP_CIPHER *EVP_##cname##_##mode(void) { return &OPENSSL_GLOBAL_ITEM_NAME(cname##_##mode); }
+
+#else
+#define BLOCK_CIPHER_def1(cname, nmode, mode, MODE, kstruct, nid, block_size, \
+			  key_len, iv_len, flags, init_key, cleanup, \
+			  set_asn1, get_asn1, ctrl) \
+CONST_EVP_CIPHER_ITEM(cname##_##mode, nid##_##nmode, block_size, key_len, iv_len,\
+	((flags) | EVP_CIPH_##MODE##_MODE), init_key, cname##_##mode##_cipher, cleanup,\
+	kstruct, NULL , NULL, NULL, NULL)\
+const EVP_CIPHER *EVP_##cname##_##mode(void) { return &OPENSSL_GLOBAL_ITEM_NAME(cname##_##mode); }
+#endif
+#endif
 
 #define BLOCK_CIPHER_def_cbc(cname, kstruct, nid, block_size, key_len, \
 			     iv_len, flags, init_key, cleanup, set_asn1, \
@@ -172,6 +207,24 @@
 BLOCK_CIPHER_def1(cname, ecb, ecb, ECB, kstruct, nid, block_size, key_len, \
 		  0, flags, init_key, cleanup, set_asn1, get_asn1, ctrl)
 
+#if !defined(_SSL_USE_OPENSSL_) && !defined(EXTERNAL_SSL_OPENSSL_IMPLEMENTATION)
+
+#define BLOCK_CIPHER_defs(cname, kstruct, \
+			  nid, block_size, key_len, iv_len, cbits, flags, \
+			  init_key, cleanup, set_asn1, get_asn1, ctrl) \
+BLOCK_CIPHER_def_cbc(cname, kstruct, nid, block_size, key_len, iv_len, flags, \
+		     init_key, cleanup, set_asn1, get_asn1, ctrl) \
+BLOCK_CIPHER_def_cfb(cname, kstruct, nid, key_len, iv_len, cbits, \
+		     flags, init_key, cleanup, set_asn1, get_asn1, ctrl) \
+BLOCK_CIPHER_def_ofb(cname, kstruct, nid, key_len, iv_len, cbits, \
+		     flags, init_key, cleanup, set_asn1, get_asn1, ctrl) \
+BLOCK_CIPHER_def_ecb(cname, kstruct, nid, block_size, key_len, iv_len, flags, \
+		     init_key, cleanup, set_asn1, get_asn1, ctrl)
+
+#else
+
+#ifdef OPENSSL_USE_CFB_CIPHERS
+
 #define BLOCK_CIPHER_defs(cname, kstruct, \
 			  nid, block_size, key_len, iv_len, cbits, flags, \
 			  init_key, cleanup, set_asn1, get_asn1, ctrl) \
@@ -179,10 +232,22 @@
 		     init_key, cleanup, set_asn1, get_asn1, ctrl) \
 BLOCK_CIPHER_def_cfb(cname, kstruct, nid, key_len, iv_len, cbits, \
 		     flags, init_key, cleanup, set_asn1, get_asn1, ctrl) \
+			 /*
 BLOCK_CIPHER_def_ofb(cname, kstruct, nid, key_len, iv_len, cbits, \
 		     flags, init_key, cleanup, set_asn1, get_asn1, ctrl) \
 BLOCK_CIPHER_def_ecb(cname, kstruct, nid, block_size, key_len, flags, \
 		     init_key, cleanup, set_asn1, get_asn1, ctrl)
+			 */
+#else
+
+#define BLOCK_CIPHER_defs(cname, kstruct, \
+			  nid, block_size, key_len, iv_len, cbits, flags, \
+			  init_key, cleanup, set_asn1, get_asn1, ctrl) \
+BLOCK_CIPHER_def_cbc(cname, kstruct, nid, block_size, key_len, iv_len, flags, \
+		     init_key, cleanup, set_asn1, get_asn1, ctrl)
+
+#endif
+#endif
 
 
 /*
@@ -342,4 +407,65 @@
 
 	} /* EVP_PKEY_METHOD */;
 
+#define CONST_EVP_PKEY_METHOD_ITEM(cname, \
+	a_pkey_id, \
+	a_flags, \
+	a_init, \
+	a_copy, \
+	a_cleanup, \
+	a_paramgen_init, \
+	a_paramgen, \
+	a_keygen_init, \
+	a_keygen, \
+	a_sign_init, \
+	a_sign, \
+	a_verify_init, \
+	a_verify, \
+	a_verify_recover_init, \
+	a_verify_recover, \
+	a_signctx_init, \
+	a_signctx, \
+	a_verifyctx_init, \
+	a_verifyctx, \
+	a_encrypt_init, \
+	a_encrypt, \
+	a_decrypt_init, \
+	a_decrypt, \
+	a_derive_init, \
+	a_derive, \
+	a_ctrl, \
+	a_ctrl_str \
+) \
+	OPENSSL_PREFIX_CONST_ITEM(extern, EVP_PKEY_METHOD, cname, libopeay) \
+		CONST_ITEM_ENTRY_START( pkey_id,             a_pkey_id) \
+		CONST_ITEM_ENTRY_SINGLE(flags,               a_flags) \
+		CONST_ITEM_ENTRY_SINGLE(init,                a_init) \
+		CONST_ITEM_ENTRY_SINGLE(copy,                a_copy) \
+		CONST_ITEM_ENTRY_SINGLE(cleanup,             a_cleanup) \
+		CONST_ITEM_ENTRY_SINGLE(paramgen_init,       a_paramgen_init) \
+		CONST_ITEM_ENTRY_SINGLE(paramgen,            a_paramgen) \
+		CONST_ITEM_ENTRY_SINGLE(keygen_init,         a_keygen_init) \
+		CONST_ITEM_ENTRY_SINGLE(keygen,              a_keygen) \
+		CONST_ITEM_ENTRY_SINGLE(sign_init,           a_sign_init) \
+		CONST_ITEM_ENTRY_SINGLE(sign,                a_sign) \
+		CONST_ITEM_ENTRY_SINGLE(verify_init,         a_verify_init) \
+		CONST_ITEM_ENTRY_SINGLE(verify,              a_verify) \
+		CONST_ITEM_ENTRY_SINGLE(verify_recover_init, a_verify_recover_init) \
+		CONST_ITEM_ENTRY_SINGLE(verify_recover,      a_verify_recover) \
+		CONST_ITEM_ENTRY_SINGLE(signctx_init,        a_signctx_init) \
+		CONST_ITEM_ENTRY_SINGLE(signctx,             a_signctx) \
+		CONST_ITEM_ENTRY_SINGLE(verifyctx_init,      a_verifyctx_init) \
+		CONST_ITEM_ENTRY_SINGLE(verifyctx,           a_verifyctx) \
+		CONST_ITEM_ENTRY_SINGLE(encrypt_init,        a_encrypt_init) \
+		CONST_ITEM_ENTRY_SINGLE(encrypt,             a_encrypt) \
+		CONST_ITEM_ENTRY_SINGLE(decrypt_init,        a_decrypt_init) \
+		CONST_ITEM_ENTRY_SINGLE(decrypt,             a_decrypt) \
+		CONST_ITEM_ENTRY_SINGLE(derive_init,         a_derive_init) \
+		CONST_ITEM_ENTRY_SINGLE(derive,              a_derive) \
+		CONST_ITEM_ENTRY_SINGLE(ctrl,                a_ctrl) \
+		CONST_ITEM_ENTRY_SINGLE(ctrl_str,            a_ctrl_str) \
+	CONST_ITEM_ENTRY_END
+
 void evp_pkey_set_cb_translate(BN_GENCB *cb, EVP_PKEY_CTX *ctx);
+
+#endif // !HEADER_EVP_LOCL_H
